
// WrapFlocking3D.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th
// Sirinart Sakarin, March 2003, s4210315@calvin.coe.psu.ac.th

/* Houfující se predátory a kořisti vytváří a přidává do scény 
   metoda addFlockingBoids(), stejně jako překážky pro agenty.

   Zbytek kódu je standardní.
*/

import javax.swing.*;
import java.awt.*;
import java.util.*;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.vp.*;


public class WrapFlocking3D extends JPanel
// Uchovává 3D-canvas, na němž se zobrazuje načtený obrázek
{
  private static final int PWIDTH = 512;   // velikost panelu
  private static final int PHEIGHT = 512; 
  private static final int BOUNDSIZE = 100;  // větší než svět

  private static final Point3d USERPOSN = new Point3d(0,5,20);
    // počáteční pozice uživatele



  private SimpleUniverse su;
  private BranchGroup sceneBG;
  private BoundingSphere bounds;   // pro uzly prostředí



  public WrapFlocking3D(int numPreds, int numPrey, int numObs)
  // Panel uchovávající 3D-canvas: obvyklý způsob propojení knihoven Java 3D a Swing
  {
    setLayout( new BorderLayout() );
    setOpaque( false );
    setPreferredSize( new Dimension(PWIDTH, PHEIGHT));

    GraphicsConfiguration config =
                    SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas3D = new Canvas3D(config);
    add("Center", canvas3D);
    canvas3D.setFocusable(true);     // předej focus herní obrazovce
    canvas3D.requestFocus();

    su = new SimpleUniverse(canvas3D);
    createSceneGraph(numPreds, numPrey, numObs);
    initUserPosition();        // nastav stanoviště pozorovatele
    orbitControls(canvas3D);   // ovládací prvky pro pohyb tohoto stanoviště
    
    su.addBranchGraph( sceneBG );
  } // konec metody: WrapFlocking3D()


  private void createSceneGraph(int numPreds, int numPrey, int numObs) 
  // inicializuje scénu
  { 
    sceneBG = new BranchGroup();
    bounds = new BoundingSphere(new Point3d(0,0,0), BOUNDSIZE);   

    lightScene();         // přidej světla
    addBackground();      // přidej oblohu
    sceneBG.addChild( new CheckerFloor().getBG() );  // přidej podlahu

    addFlockingBoids(numPreds, numPrey, numObs);
  } // konec metody: createSceneGraph()


  private void lightScene()
  /* Jedno ambientní světlo, 2 směrová světla */
  {
    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

    // připrav ambientní světlo
    AmbientLight ambientLightNode = new AmbientLight(white);
    ambientLightNode.setInfluencingBounds(bounds);
    sceneBG.addChild(ambientLightNode);

    // připrav směrová světla
    Vector3f light1Direction  = new Vector3f(-1.0f, -1.0f, -1.0f);
       // vlevo, dolů, dozadu 
    Vector3f light2Direction  = new Vector3f(1.0f, -1.0f, 1.0f);
       // vpravo, dolů, dopředu

    DirectionalLight light1 = 
            new DirectionalLight(white, light1Direction);
    light1.setInfluencingBounds(bounds);
    sceneBG.addChild(light1);

    DirectionalLight light2 = 
        new DirectionalLight(white, light2Direction);
    light2.setInfluencingBounds(bounds);
    sceneBG.addChild(light2);
  }  // konec metody: lightScene()


  private void addBackground()
  // modrá obhloha
  { Background back = new Background();
    back.setApplicationBounds( bounds );
    back.setColor(0.17f, 0.65f, 0.92f);    // barva oblohy
    sceneBG.addChild( back );
  }  // konec metody: addBackground()


  private void orbitControls(Canvas3D c)
  /* Třída OrbitBehaviour umožňuje uživateli otáčet, přibližovat a oddalovat scénu. */
  {
    OrbitBehavior orbit = 
        new OrbitBehavior(c, OrbitBehavior.REVERSE_ALL);
    orbit.setSchedulingBounds(bounds);

    ViewingPlatform vp = su.getViewingPlatform();
    vp.setViewPlatformBehavior(orbit);      
  }  // konec metody: orbitControls()



  private void initUserPosition()
  // Pomocí metody lookAt() nastaví počáteční výhled uživatele
  {
    ViewingPlatform vp = su.getViewingPlatform();
    TransformGroup steerTG = vp.getViewPlatformTransform();

    Transform3D t3d = new Transform3D();
    steerTG.getTransform(t3d);

    // argumenty jsou: pozice pozorovatele, kam se dívá, směr nahoru
    t3d.lookAt( USERPOSN, new Point3d(0,0,0), new Vector3d(0,1,0));
    t3d.invert();

    steerTG.setTransform(t3d);
  }  // konec metody: initUserPosition()



  // ---------------------- houfující se agenti -----------------


  private void addFlockingBoids(int numPreds, int numPrey, int numObs)
  { 
    // vytvoř překážky
    Obstacles obs = new Obstacles(numObs);
    sceneBG.addChild( obs.getObsBG() );  // přidej překážky do scény

    // vytvoř správce houfu kořistí
    PredatorBehavior predBeh = new PredatorBehavior(numPreds, obs);
    predBeh.setSchedulingBounds(bounds);
    sceneBG.addChild( predBeh.getBoidsBG() );  // přidej predátory do scény

    // vytvoř kořisti
    PreyBehavior preyBeh = new PreyBehavior(numPrey, obs);
    preyBeh.setSchedulingBounds(bounds);
    sceneBG.addChild( preyBeh.getBoidsBG() );  // přdej kořisti do scény

    // informuj objekty chování o sobě navzájem
    predBeh.setPreyBeh( preyBeh );
    preyBeh.setPredBeh( predBeh );

  } // konec metody: addFlockingBoids()


} // konec třídy: WrapFlocking3D